#ifndef MESH_H_
#define MESH_H_

#include <stdint.h>
#include <string>
#include <vector>
#include <gmath/gmath.h>

enum {
	MESH_VERTEX = 1,
	MESH_NORMAL = 2,
	MESH_TEXTURE = 3,
	MESH_INDEX = 4,
	MESH_TANGENT = 5
};

class Mesh {
private:
	// call before draw in gl
	virtual void update_vertex_data() = 0;
public:
	std::vector<uint16_t> indices;
	std::vector<Vec3> vertices;
	std::vector<Vec3> normals;
	std::vector<Vec3> tangents;
	std::vector<Vec2> tex_coords;

	std::string name;
	unsigned int mat_idx;

	unsigned int which_mask;

	Mesh();
	virtual ~Mesh() = 0;
};

#endif // MESH_H_