#ifndef OBJECT_H_
#define OBJECT_H_

#include <string>

#include <gmath/gmath.h>

class Mesh;
class ShaderProgram;
class Texture;

enum OType {
	OBJ_MESH,
	OBJ_PT_LIGHT,
	OBJ_CAMERA
};

struct Material {
	Vec3 diffuse;
	Vec3 specular;
	float shininess;

	Texture *dtex; // diffuse
	std::string name;
};

class Object {
public:
	Mat4 transform;
	Material *material;
	Mesh *mesh;

	Object();
	~Object();
};

#endif // OBJECT_H_
